% Demo MULRM model
% Author: Francisco Alexandre A. Souza
% v. 1.0

% clean workspace
clc;close all;clear
% Load data

% % clc;clear;close all
Z = importdata('catActivAll.arff');
X1 = Z.data(1:10:5800,1:end-1);
Y1 = Z.data(1:10:5800,end);
X2 = Z.data(5801:end,1:end-1);
Y2 = Z.data(5801:end,end);
X1(:,[3 4 15]) = []; % remove inconsistent vaiables
X2(:,[3 4 15]) = [];
X = [X1;X2]; Y = [Y1;Y2];
A = [X Y];
A(sum(isnan(A),2)>0,:)=[];
% A = ss_deletedatamissing(A);
temp_X = A(:,1:end-1);
temp_Y = A(:,end);
% divide into train and test
X_train = temp_X(1:194,:);
Y_train = temp_Y(1:194,:);
X_test = temp_X(195:end,:);
Y_test = temp_Y(195:end,:);
% normalize data
[X_train,psx]=mapminmax(X_train');X_train=X_train';
X_test=mapminmax('apply',X_test',psx)';
[Y_train,psy]=mapminmax(Y_train');Y_train=Y_train';
Y_test=mapminmax('apply',Y_test',psy)';

% get model parameters
[M,N] = size(X_train);
SW =10; % window size
lambda=(SW-1)/SW; % forgetting factor
per = 1; % percentage of update = 100*per 

% Initialize model with train data
par=mulrm_initialization(X_train,Y_train);
ActualMeanPi_k = par.ActualMeanPi_k;
thetai = par.thetai;
beta = par.beta;
mean_errorEachModel = par.mean_errorEachModel;
Pi = par.Pi;
ind =1;

y_predicted_ind = zeros(1,size(X_test,1));
for i=1:size(X_test,1)
    x = X_test(i,:);
    y = Y_test(i);
    
    % predict
    y_predicted_ind(i) = mulrm_predict(x,ActualMeanPi_k,thetai);
    
    % update
    if(ind==per)
        ind=0;
        [thetai,Pi,ActualMeanPi_k,beta,Q] = mulrm_update(x',y,thetai,Pi,ActualMeanPi_k,beta,SW);
        Q_ind_fim(i) = mean(Q);
        aaa(i,:) = ActualMeanPi_k;
    end
    ind = ind+1;
end
ActualMeanPi_k_perm_fim = ActualMeanPi_k;

plot([Y_test y_predicted_ind'])
legend('Real','Predicted')
mse(Y_test-y_predicted_ind')
